---
workflow:
  rules:
    - if: "$CI_COMMIT_TAG" # For tags on main branch
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH" # For any commits on main branch
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"' # For merge requests

stages:
  - plan
  - code
  - build
  - test
  - release
  - deploy
  - operate
  - monitor

services:
  - docker:dind

variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2
  TERM: "xterm-256color"

default:
  image: registry.gitlab.com/neosoft-group/practice/devops/public/hub/tools/gitpod/ubuntu:latest
  before_script:
    - task bootstrap

code:
  stage: code
  needs: []
  script:
    - task code

build:
  stage: build
  needs: []
  script:
    - task build

test:
  stage: test
  needs: []
  script:
    - task test

release:
  stage: release
  needs: ["build", "test"]
  script:
    - task release
